package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxHfsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxHfsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxHfsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;

@RestController
@RequestMapping("/wxhfsq")
@Api(tags="微信-恢复用水申请接口")
public class WxHfsqController {

    @Autowired
    private  WxHfsqService wxHfsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxHfsqVo>> getWxHfsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxHfsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxHfsqVo> wxPage = wxHfsqService.getWxHfsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }


    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxHfsqPage(Page page, @ModelAttribute WxHfsq wxHfsq) {
      return ResultRespone.success(wxHfsqService.page(page, Wrappers.query(wxHfsq)));
    }


    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(wxHfsqService.getById(id));
    }

    @ApiOperation(value = "新增微信-恢复用水申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxHfsq wxHfsq) {
      return ResultRespone.success(wxHfsqService.save(wxHfsq));
    }

    @ApiOperation(value = "修改微信-恢复用水申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxHfsq wxHfsq) {
      return ResultRespone.success(wxHfsqService.updateById(wxHfsq));
    }

    @ApiOperation(value = "通过ID删除微信-恢复用水申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(wxHfsqService.removeById(id));
    }

    @ApiOperation(value = "通过ID批量删除微信-恢复用水申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxHfsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
